VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5895
   LinkTopic       =   "Form1"
   ScaleHeight     =   1860
   ScaleWidth      =   5895
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtTableDest 
      Height          =   285
      Left            =   3600
      TabIndex        =   8
      Text            =   "People"
      Top             =   480
      Width           =   2175
   End
   Begin VB.TextBox txtTableSource 
      Height          =   285
      Left            =   960
      TabIndex        =   6
      Text            =   "Employees"
      Top             =   480
      Width           =   2175
   End
   Begin VB.TextBox txtCriterion 
      Height          =   285
      Left            =   960
      TabIndex        =   4
      Text            =   "EmployeeId > 4000"
      Top             =   840
      Width           =   4815
   End
   Begin VB.TextBox txtDatabase 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Top             =   120
      Width           =   4815
   End
   Begin VB.CommandButton cmdCopy 
      Caption         =   "Copy"
      Default         =   -1  'True
      Height          =   375
      Left            =   2760
      TabIndex        =   0
      Top             =   1320
      Width           =   735
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "To"
      Height          =   195
      Index           =   3
      Left            =   3240
      TabIndex        =   7
      Top             =   480
      Width           =   195
   End
   Begin VB.Label Label1 
      Caption         =   "Copy"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Condition"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   840
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Database"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCopy_Click()
Dim db As DAO.Database
Dim dest_field_index() As Integer
Dim td_src As TableDef
Dim td_dst As TableDef
Dim field_src As Field
Dim field_dst As Field
Dim i As Integer
Dim criterion As String
Dim rs_src As DAO.Recordset
Dim rs_dst As DAO.Recordset
Dim num_copied As Integer

    ' Open the database.
    Set db = DBEngine.Workspaces(0).OpenDatabase( _
        txtDatabase.Text, ReadOnly:=False)

    ' Find the tables.
    Set td_src = db.TableDefs(txtTableSource.Text)
    Set td_dst = db.TableDefs(txtTableDest.Text)

    ' Find the common fields.
    ReDim dest_field_index(0 To td_src.Fields.Count - 1)
    For i = 0 To td_src.Fields.Count - 1
        ' Get the source field.
        Set field_src = td_src.Fields(i)

        ' Find the matching destination field.
        On Error Resume Next
        Set field_dst = td_dst.Fields(field_src.Name)
        If Err.Number <> 0 Then
            On Error GoTo 0
            dest_field_index(i) = -1
            Err.Clear
        Else
            On Error GoTo 0
            dest_field_index(i) = field_dst.OrdinalPosition - 1
        End If
    Next i

    ' Open the Recordsets.
    Set rs_src = db.OpenRecordset(txtTableSource.Text, dbOpenDynaset)
    Set rs_dst = db.OpenRecordset(txtTableDest.Text, dbOpenDynaset)

    ' Copy the records.
    criterion = txtCriterion.Text
    num_copied = 0
    rs_src.FindFirst criterion
    Do Until rs_src.NoMatch
        num_copied = num_copied + 1
        rs_dst.AddNew
        For i = 0 To td_src.Fields.Count - 1
            If dest_field_index(i) >= 0 Then
                rs_dst.Fields(dest_field_index(i)).Value = _
                    rs_src.Fields(i).Value
            End If
        Next i
        rs_dst.Update

        ' Get the next matching record.
        rs_src.FindNext criterion
    Loop

    ' Clean up.
    rs_src.Close
    rs_dst.Close
    db.Close

    MsgBox "Copied " & num_copied & " records"
End Sub
Private Sub Form_Resize()
Const GAP As Single = 120

Dim wid As Single
Dim db_path As String

    db_path = App.Path
    If Right$(db_path, 1) <> "\" Then db_path = db_path & "\"
    txtDatabase.Text = db_path & "People.mdb"

    wid = ScaleWidth - txtDatabase.Left - GAP
    If wid < GAP Then wid = GAP
    txtDatabase.Width = wid
    txtCriterion.Width = wid

    cmdCopy.Left = (ScaleWidth - cmdCopy.Width) / 2
End Sub

